;;; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;
;;;     			     ANSIL
;;; 		      Advanced Network Simulator In Lisp
;;; 		      ----------------------------------
;;;
;;;				  Written By
;;;			       Peter J. Angeline
;;;			      Gregory M. Saunders
;;;
;;;			   The Ohio State University
;;;		       Laboratory for AI Research (LAIR)
;;;			     Columbus, Ohio, 43210
;;;
;;;			   Copyright (c) 1991, 1992
;;;
;;; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; ---------------------------------------------------------------------- 
;;; File: abcd-raam.lisp - an example.  Converges in ~150 epochs.
;;;
;;; Author: Gregory M Saunders
;;;
;;; License: This code may be distributed free of charge.  This code may not be
;;; incorporated into any production software of any type or any code which is
;;; sold without the express written consent of the authors.  Modifications and
;;; inclusions for other types of software are permitted, provided that this
;;; header remains unchanged and included in all subsequent versions of the
;;; code.
;;;
;;; Disclaimer: The authors of this code make no claims as to its
;;; validity, and are in no way responsible for any errors contained within.
;;; 
;;; File description:
;;;
;;; Creation date: March 19, 1992, Version 2.01
;;; ----------------------------------------------------------------------
;;;
;;;
;;;                         Change Log
;;;                         ----------
;;;
;;; ----------------------------------------------------------------------

(defun setup (&aux e d tn)
  (setf raam (create-raam :repwidth 2
		       :valence 2
		       :symtab '((a (0 0))
				 (b (0 1))
				 (c (1 0))
				 (d (1 1)))
		       :tset '((a b)
			       (c d)
			       ((a b) (c d))
			       )))
  (setf e (raam-encoder raam))
  (setf d (raam-decoder raam))
  (setf tn (raam-termnet raam))
  (set-network e :sp-add .15)
  (set-network d :sp-add .15)
  (set-network tn :sp-add .15)
  nil)

(defun demo ()
  (format t "Raam demo...~%")
  (setup)
  (raam-train raam :display 10))

(demo)
