;;; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;
;;;     			     ANSIL
;;; 		      Advanced Network Simulator In Lisp
;;; 		      ----------------------------------
;;;
;;;				  Written By
;;;			       Peter J. Angeline
;;;			      Gregory M. Saunders
;;;
;;;			   The Ohio State University
;;;		       Laboratory for AI Research (LAIR)
;;;			     Columbus, Ohio, 43210
;;;
;;;			   Copyright (c) 1991, 1992
;;;
;;; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; ---------------------------------------------------------------------- 
;;; File: xor.lisp - an example.  Converges in ~600 epochs.  Converges in ~350
;;; epochs with sp-add set to .15.
;;;
;;; Author: Gregory M Saunders
;;;
;;; License: This code may be distributed free of charge.  This code may not be
;;; incorporated into any production software of any type or any code which is
;;; sold without the express written consent of the authors.  Modifications and
;;; inclusions for other types of software are permitted, provided that this
;;; header remains unchanged and included in all subsequent versions of the
;;; code.
;;;
;;; Disclaimer: The authors of this code make no claims as to its
;;; validity, and are in no way responsible for any errors contained within.
;;; 
;;; File description:
;;;
;;; Creation date: March 19, 1992, Version 2.01
;;; ----------------------------------------------------------------------
;;;
;;;
;;;                         Change Log
;;;                         ----------
;;;
;;; ----------------------------------------------------------------------

(defun setup ()
  (setf net (create-network 5 :type 'feed-forward :layers '(2 2 1)))
;  (set-weight net 0 3 -.1d0)
;  (set-weight net 1 3 .4d0)
;  (set-weight net 2 3 .2d0)
;  (set-weight net 0 4 .2d0)
;  (set-weight net 1 4 -.6d0)
;  (set-weight net 2 4 -.12d0)
;  (set-weight net 0 5 .5d0)
;  (set-weight net 3 5 -.3d0)
;  (set-weight net 4 5 -.4d0)
  (add-pattern net '(0 0) '(0))
  (add-pattern net '(0 1) '(1))
  (add-pattern net '(1 0) '(1))
  (add-pattern net '(1 1) '(0)))

(defun demo ()
  (setup)
  (network-train net :display 10))

(demo)
